from codequick import Route, Script, Listitem
from codequick.utils import color
from functools import lru_cache
@lru_cache
@Route.register
def index_fshare(plugin):
	streams = [
		(color('MỚI NHẤT', 'yellow'), 'https://mi3s.top/thumb/fshare/moicapnhat.png', 'https://thuvienhd.xyz/recent/page/'),
		('4K - H265', 'https://mi3s.top/thumb/fshare/4k.png', 'https://thuvienhd.xyz/genre/4k/page/'),
		('Bluray nguyên gốc', 'https://mi3s.top/thumb/fshare/bluray.png', 'https://thuvienhd.xyz/genre/bluray-nguyen-goc/page/'),
		('Thuyết minh', 'https://mi3s.top/thumb/fshare/thuyetminh.png', 'https://thuvienhd.xyz/genre/thuyet-minh-tieng-viet/page/'),
		('Lồng tiếng', 'https://mi3s.top/thumb/fshare/longtieng.png', 'https://thuvienhd.xyz/genre/long-tieng-tieng-viet/page/'),
		('Hoạt hình', 'https://mi3s.top/thumb/fshare/anime.png', 'https://thuvienhd.xyz/genre/animation/page/'),
		('Phim lẻ', 'https://mi3s.top/thumb/fshare/phimle.png', 'https://thuvienhd.xyz/genre/phim-le/page/'),
		('Phim bộ', 'https://mi3s.top/thumb/fshare/phimbo.png', 'https://thuvienhd.xyz/genre/series/page/')
	]
	s2 = [
		('NHẬP CODEPLAY', 'https://mi3s.top/thumb/fshare/playcode.png', '/resources/lib/mkd/onfshare/codenumber:index_number'),
		('Fshare Favourite', 'https://mi3s.top/thumb/fshare/yeuthich.png', '/resources/lib/mkd/onfshare/ifshare:fs_favorite'),
		('VNM Tuyển Chọn', 'https://mi3s.top/thumb/fshare/dexuat.png', '/resources/lib/mkd/onfshare/timfshare:index_pdx'),
	]
	s3 = [
		('HdVietNam', 'https://mi3s.top/thumb/fshare/thuvienhd.png', '/resources/lib/mkd/onfshare/hdvn:index_hdvn'),
		('Thư viện HD', 'https://mi3s.top/thumb/fshare/tvhd.png', '/resources/lib/mkd/onfshare/thuvienhd:index_thuvienhd'),
		('Thư viện Cine', 'https://mi3s.top/thumb/fshare/thuviencine.png', '/resources/lib/mkd/onfshare/thuviencine:index_thuviencine'),
		('TOP FSHARE', 'https://mi3s.top/thumb/fshare/topfshare.png', '/resources/lib/mkd/onfshare/ifshare:fs_topfollow')
	]
	yield Listitem.search(Route.ref('/resources/lib/mkd/onfshare/timfshare:searchfs'))
	if Script.setting.get_string('historyfs') == 'true':
		yield Listitem.from_dict(**{'label': 'LỊCH SỬ XEM',
		'art': {'thumb': 'https://mi3s.top/thumb/fshare/lichsu.png',
		'poster': 'https://mi3s.top/thumb/fshare/lichsu.png'},
		'callback': Route.ref('/resources/lib/mkd/onfshare/ifshare:index_daxem')})
	if Script.setting.get_string('taifshare') == 'true':
		yield Listitem.from_dict(**{'label': 'Tệp đã tải',
		'art':{'thumb':'https://mi3s.top/thumb/fshare/datai.png',
		'poster':'https://mi3s.top/thumb/fshare/datai.png'},
		'callback': Route.ref('/resources/lib/mkd/onfshare/datai:index_datai')})
	for namekey, bannerkey, routekey in s2:
		i2 = Listitem()
		i2.label = namekey
		i2.info['mediatype'] = 'tvshow'
		i2.art['thumb'] = i2.art['poster'] = bannerkey
		i2.set_callback(Route.ref(routekey))
		yield i2
	yield trending()
	for name_key, banner_key, url_key in streams:
		item = Listitem()
		item.label = name_key
		item.info['mediatype'] = 'tvshow'
		item.art['thumb'] = item.art['poster'] = banner_key
		item.set_callback(Route.ref('/resources/lib/mkd/onfshare/thuvienhd:thuvienhd_page'), url_key, 1)
		yield item
	for name, banner, route in s3:
		i3 = Listitem()
		i3.label = name
		i3.info['mediatype'] = 'tvshow'
		i3.art['thumb'] = i3.art['poster'] = banner
		i3.set_callback(Route.ref(route))
		yield i3
	yield speedtestfs()
@lru_cache
def trending():
	item = Listitem()
	item.label = color('TRENDING', 'yellow')
	item.info['mediatype'] = 'tvshow'
	item.art['thumb'] = item.art['poster'] = 'https://mi3s.top/thumb/fshare/hot.png'
	item.set_callback(Route.ref('/resources/lib/mkd/onfshare/thuviencine:thuviencine_page'), 'https://thuviencine.com/top/', 1)
	return item
@lru_cache
def speedtestfs():
	i4 = Listitem()
	i4.label = 'Đo tốc độ Fshare'
	i4.art['thumb'] = i4.art['poster'] = 'https://mi3s.top/thumb/Speedtest.png'
	i4.set_callback(Script.ref('/resources/lib/download:speedtestfs'))
	return i4